def result_schulze():
    ### Procède au dépouillement du vote selon la méthode de Schulze
    resultat={}
    Q_id=request.args[0]
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    
    #Récupération des réponses et leurs index 
    les_Reponses=[]
    num_reponses=[]
    for r in db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        les_Reponses.append(r.titre)
        num_reponses.append(str(r.id))
        
    resultat=traduit_result(resultat,num_reponses)
    num=[str(elem) for elem in range(1,len(num_reponses)+1)]
    
    PD={}
    for i in num:
        for j in num:
            if i != j:
                ij=i+'>'+j
                ji=j+'>'+i
                PD[ij]=resultat.get(ij,0)-resultat.get(ji,0)
                
    for i in num:
        for j in num:
            if i != j:
                for k in num:
                    if i != k and j != k:
                        jk=j+'>'+k
                        ji=j+'>'+i
                        ik=i+'>'+k
                        PD[jk]=max(PD[jk],min(PD[ji],PD[ik]))
    winner=[]
                        
    for i in num:
        winner.append(i)
    for i in num:
        for j in num:
            if i != j:
                ji=j+'>'+i
                ij=i+'>'+j
                if PD[ji] > PD[ij] and i in winner:
                    del(winner[winner.index(i)])
                  
    return dict(Q=la_Q.description,R=les_Reponses,resultat=resultat,winner=winner)
                    
def str_to_dict(chaine):
    dico={}
    if chaine==None or chaine=='{}':
        return dico
    chaine=chaine.replace(' ','')
    chaine=chaine.replace('{','')
    chaine=chaine.replace('}','')
    chaine=chaine.replace("'",'')
    liste=chaine.split(',')
    for elem in liste:
        l_e=elem.split(':')
        dico[l_e[0]]=int(l_e[1])
    return dico
    
def traduit_result(resultat,num_reponses):
    #traduit des résultats de type {'23>25':12,..} en {'1>3':12,..}
    new_resultat={}
    for clef in resultat:        
        R=clef.split('>')
        new_clef=str(num_reponses.index(R[0])+1)+'>'+str(num_reponses.index(R[1])+1)
        new_resultat[new_clef]=resultat[clef]
    return new_resultat